<!DOCTYPE html>
<html>
<head>
  <meta charset="UTF-8">
  <title>Form work1</title>
  <script>
    /*
      Задание:
        Сделать шиблонизатор элемента по:
        Ширине input type=range
        Цвету  input type=color
        Высоте input type=number
        Скругление углов input type=number
        Padding input type=number

      Свойсвта: https://developer.mozilla.org/en-US/docs/Web/CSS/CSS_Properties_Reference

        + Сделать выборку цвета из рандомных 20 цветов которые выбираются из появившегося блока :
        https://s3.envato.com/files/230412754/screenshots/1.png
        За заготовку для рандома цвета использовать функцию из первых занятий.

    */

    document.addEventListener('DOMContentLoaded', function () {
      const myWidth = document.getElementById('myWidth');
      const myHeight = document.getElementById('myHeight');
      const myRadius = document.getElementById('myRadius');
      const myPadding = document.getElementById('myPadding');
      const myColor = document.getElementById('myColor');

      function createElem (elem, className, parent = document.body) {
        let element = document.createElement(elem);
        element.classList.add(className);
        parent.appendChild(element);
        
        return element
      }

      function getColor () {
        function getRandomPart(min = 0, max = 256) {
          let number = Math.floor(Math.random() * (max - min)) + min;  
          return number
        }
        return `rgb(${getRandomPart()}, ${getRandomPart()}, ${getRandomPart()})`
      }

      const popup = createElem('div', 'popup');

      for(let i = 0; i < 20; i++) {
        let circle = createElem('div', 'circle', popup);
        circle.style.background = getColor();
      }

      myWidth.addEventListener('input', function(event) {
        result.style.width = event.target.value + 'px';
      });

      myHeight.addEventListener('input', function(event) {
        result.style.height = event.target.value + 'px';
      });

      myRadius.addEventListener('input', function(event) {
        result.style.borderRadius = event.target.value + '%';
      });

      myPadding.addEventListener('input', function(event) {
        result.style.padding = event.target.value + 'px';
      });

      myColor.addEventListener('click', function(event) {
        event.preventDefault();
        popup.classList.toggle('show');
        popup.addEventListener('click', function (e) {
        let target = e.target;
        let background;
        if (target.classList.contains('circle')) {
          background = target.style.background; 
        }
        result.style.background = background;
      });
      });
    });
  </script>
</head>
<body>
  <div class="Templating">
    <form>
      <input type="range" id="myWidth" min="10" max="200" step="2"/>
      <input type="range" id="myHeight" min="10" max="200" step="3"/>
      <input type="range" id="myRadius" min="1" max="50" step="1"/>
      <input type="range" id="myPadding" min="10" max="100" step="1"/>
      <input type="color" id="myColor"/>
    </form>

    <div class="TemplatingResult">
      <div id="result" class="result"></div>
    </div>
  </div>

  <style>
    body {
      width: 600px;
      position: relative;
    }
    #colors{
      width: 200px;
      display: flex;
      flex-wrap: wrap;
    }
    .result{
      width: 50px;
      background: gray;
      box-sizing: border-box;
      padding: 10px;
    }
    #MyValidateForm{
      width: 350px;
      display: flex;
      flex-direction: column;
    }

    #MyValidateForm input{
      margin-bottom: 10px;
      box-sizing: border-box;
      padding: 10px 20px;
    }
    .circle{
      width: 30px;
      height: 30px;
      background: #eee;
      border-radius: 50%;
      border: 2px solid #fff;
      cursor: pointer;
    }
    .popup {
      width: 203px;
      height: 155px;
      position: absolute;
      right: 0;
      top: 40px;
      background-color: #efefef;
      border: 1px solid #ccc;
      border-radius: 15px;
      flex-wrap: wrap;
      justify-content: space-around;
      padding: 10px;
      display: none;
    }
    .popup.show{
      display: flex;
    }
  </style>
</body>
</html>
